
> module Main where
> -- import qualified Unicode as U
> import Yahc.Rules (showRules)
> import Yahc.Interaction (checkFile, checkStdIn, interaction, welcome, welcomeInt)
> import Yahc.Checker(initialSt)

> import Control.Monad.State
> import System.Environment
> import System.Console.GetOpt
> import System.Console.Editline.Readline

> data Flag = Rules 
>           | Version 
>           | Help
>           | Interactive
>    deriving Show
> 
> options :: [OptDescr (IO ())]
> options =
>  [ Option ['r'] ["rules"]       (NoArg optRules)         "muestra las reglas"
>  , Option ['V'] ["version"]     (NoArg optVersion)       "muestra la versión"
>  , Option ['i'] ["interactive"] (NoArg optInteractive)   "inicia una sesión interactiva"
>  , Option ['h'] ["help"]        (NoArg optHelp)          "muestra esta ayuda"
>  ]
> 

> optRules :: IO ()
> optRules = mapM_ putStrLn $ showRules []

> optVersion :: IO ()
> optVersion = putStrLn welcome

> optInteractive :: IO ()
> optInteractive = putStrLn welcomeInt >>
>                  setInhibitCompletion True >>
>                  execStateT interaction initialSt >> 
>                  return ()

> optHelp :: IO ()
> optHelp = putStrLn $ usageInfo header options
>     where header = welcome

> main :: IO ()
> main = getArgs >>= yahcOpts
 
> yahcOpts :: [String] -> IO ()
> yahcOpts argv = 
>    case getOpt Permute options argv of
>       ([],[],[])  -> execStateT checkStdIn initialSt >> return ()
>       ([],fname:_,[]) -> execStateT (checkFile fname) initialSt >> return ()
>       (o,[],[]  ) -> head o
>       (_,_,errs)  -> optHelp
